/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core/ES5/DVContainer";
import { Type, runOn, typeCast, EnumUtil, markType } from "igniteui-react-core/ES5/type";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { TrendLineType_$type } from "igniteui-react-core/ES5/TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { truncate } from "igniteui-react-core/ES5/number";
/**
 * @hidden
 */
var VerticalAnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(VerticalAnchoredCategorySeries, _super);
    function VerticalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ps = null;
        return _this;
    }
    VerticalAnchoredCategorySeries.prototype.hn = function () {
        _super.prototype.hn.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "pt", {
        get: function () {
            var _this = this;
            if (this.ps == null) {
                this.ps = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.ps;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
        return true;
    };
    VerticalAnchoredCategorySeries.prototype.mz = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.nj = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.m4.r(this.mz(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.e9 = function (a, b) {
        return this.fa(a, b, this.mz(), runOn(this, this.ny), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.fb = function (a, b) {
        return this.fc(a, b, this.mz(), runOn(this, this.ny), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.d6 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d7(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.ny));
    };
    VerticalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    VerticalAnchoredCategorySeries.prototype.lp = function (a) {
        if (!this.hasMarkers || !this.lw()) {
            return Rect.empty;
        }
        return this.pt.e$b(this, this.m0.m, a, runOn(this, this.p1));
    };
    VerticalAnchoredCategorySeries.prototype.p1 = function (a) {
        return this.or.c5(a);
    };
    VerticalAnchoredCategorySeries.prototype.dg = function (a, b) {
        if (this.df(a, b)) {
            return true;
        }
        if (this.lx(a, b)) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.ek = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.mz();
        var f = new ScalerParams(0, this.bs.mq, this.bi.br, e.b8, d);
        var g = this.m4.r(e, this.bs.mq, this.bi.br, d);
        return this.em(this.valueColumn, a, e, f, g, runOn(this, this.ny), b, c);
    };
    VerticalAnchoredCategorySeries.prototype.le = function (a, b, c) {
        var d = this.mz();
        return this.lg(a, b, c, this.m4.r(d, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.nj(), d, null, null, null);
    };
    VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.o9 = function (a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.pa = function (a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.nu = function () {
        return this.xAxis != null && this.xAxis.ck();
    };
    VerticalAnchoredCategorySeries.prototype.mt = function (a, b) {
        return this.oo(a, b, this.yAxis);
    };
    VerticalAnchoredCategorySeries.prototype.d8 = function (a) {
        return this.pt.e$a(this, a);
    };
    VerticalAnchoredCategorySeries.prototype.ny = function (a) {
        return this.ea(a, this.mz());
    };
    VerticalAnchoredCategorySeries.prototype.e5 = function (a) {
        return truncate(Math.round(this.d8(a)));
    };
    VerticalAnchoredCategorySeries.prototype.fm = function (a) {
        var b = this.e5(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    VerticalAnchoredCategorySeries.prototype.is = function (a, b, c, d) {
        _super.prototype.is.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.m8.cn.g(this.er);
                    this.i6(false);
                    this.ic();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.ht(typeCast(Axis.$, c));
                    this.ix(typeCast(Axis.$, d));
                    this.m8.cn.g(this.er);
                    this.nu();
                    this.i6(false);
                    this.ic();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.or.cy = CategoryTrendLineManagerFactory.a(this.or.cy, this.yAxis, this.jq, this, this.b2);
                }
                break;
        }
    };
    VerticalAnchoredCategorySeries.prototype.pw = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.pv = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nv;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    return VerticalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { VerticalAnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::pz', [NumericXAxis.$, null], 'YAxis::p0', [CategoryYAxis.$, null]]);
